package it.polito.bigdata.hadoop;

import java.io.IOException;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;


class Reducer1BigData extends Reducer<Text, // Input key type
		IntWritable, // Input value type
		Text, // Output key type
		IntWritable> { // Output value type

	private String firstDate;
	private int maxOutOfOrders;

	@Override
	protected void setup(Context context) throws IOException, InterruptedException {
		this.firstDate = null;
		this.maxOutOfOrders = -1;
	}

	@Override
	protected void reduce(Text key, // Input key type
			Iterable<IntWritable> values, // Input value type
			Context context) throws IOException, InterruptedException {

		String date = key.toString();
		int numOutOfOrders = 0;
		for (IntWritable val : values) {
			numOutOfOrders += val.get();
		}

		if (numOutOfOrders > this.maxOutOfOrders
				|| (this.maxOutOfOrders == numOutOfOrders && date.compareTo(this.firstDate) < 0)) {
			this.maxOutOfOrders = numOutOfOrders;
			this.firstDate = date;
		}
	}

	@Override
	protected void cleanup(Context context) throws IOException, InterruptedException {
		context.write(new Text(this.firstDate), new IntWritable(maxOutOfOrders));
	}
}
