package it.polito.bigdata.hadoop;

import java.io.IOException;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.NullWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Reducer;

class Reducer2BigData extends Reducer<NullWritable, // Input key type
		Text, // Input value type
		Text, // Output key type
		IntWritable> { // Output value type

	@Override
	protected void reduce(NullWritable key, // Input key type
			Iterable<Text> values, // Input value type
			Context context) throws IOException, InterruptedException {

		String firstDate = null;
		int maxOutOfOrders = 0;

		for (Text i : values) {
			String t = i.toString();
			String[] fields = t.split("_");
			String date = fields[0];
			int numOutOfOrders = Integer.parseInt(fields[1]);

			if (numOutOfOrders > maxOutOfOrders
					|| (maxOutOfOrders == numOutOfOrders && date.compareTo(firstDate) < 0)) {
				maxOutOfOrders = numOutOfOrders;
				firstDate = date;
			}
		}

		context.write(new Text(firstDate), new IntWritable(maxOutOfOrders));

	}
}
